/*
  -------------------------------------------------------------------
  
  Copyright (C) 2006, 2007, Andrew W. Steiner
  
  This file is part of O2scl.
  
  O2scl is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  O2scl is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with O2scl. If not, see <http://www.gnu.org/licenses/>.

  -------------------------------------------------------------------
*/

#include <o2scl/gsl_mmin_simp_b.h>

using namespace std;
using namespace o2scl;

int gsl_mmin_simp_b::nmsimplex_calc_center(const simp_state_t * state, 
					   gsl_vector *mp) {
  
  gsl_matrix *x1 = state->x1;
  
  size_t i, j;
  double val;
 
  for (j = 0; j < x1->size2; j++) {
    val = 0.0;
    for (i = 0; i < x1->size1; i++) {
      val += gsl_matrix_get (x1, i, j);
    }
    val /= x1->size1;
    gsl_vector_set (mp, j, val);
  }
 
  return GSL_SUCCESS;
}

double gsl_mmin_simp_b::nmsimplex_size(simp_state_t *state) {
  
  gsl_vector *s = state->ws1;
  gsl_vector *mp = state->ws2;
  
  gsl_matrix *x1 = state->x1;
  size_t i;
  
  double ss = 0.0;
  
  nmsimplex_calc_center (state, mp);
  
  for (i = 0; i < x1->size1; i++) {
    gsl_matrix_get_row (s, x1, i);
    gsl_blas_daxpy (-1.0, mp, s);
    ss += gsl_blas_dnrm2 (s);
  }
  
  return ss / (double) (x1->size1);
}
