/*
  -------------------------------------------------------------------
  
  Copyright (C) 2006, 2007, Andrew W. Steiner
  
  This file is part of O2scl.
  
  O2scl is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  O2scl is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with O2scl. If not, see <http://www.gnu.org/licenses/>.

  -------------------------------------------------------------------
*/
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <o2scl/rnga.h>

using namespace std;
using namespace o2scl;

#include <o2scl/test_mgr.h>
#include <o2scl/gsl_rnga.h>
#include <ctime>

int main(void) {
  test_mgr t;
  t.set_output_level(2);

  const int maxit=1000000;
  int i, j;
  long int lt1, lt2;
  double x;
  int y;

  rnga r, *r2;
  r.clock_seed();

  cout.setf(ios::scientific);

  for(i=1;i<40;i++) {
    gsl_rnga *nr=new gsl_rnga(i);

    cout.setf(ios::left);
    cout.width(14);
    if (i==1) {
      cout << "mt19937";
    } else if (i==2) {
      cout << "ranlxs0";
    } else if (i==3) {
      cout << "ranlxs1";
    } else if (i==4) {
      cout << "ranlxs2";
    } else if (i==5) {
      cout << "ranlxd1";
    } else if (i==6) {
      cout << "ranlxd2";
    } else if (i==7) {
      cout << "ranlux";
    } else if (i==8) {
      cout << "ranlux389";
    } else if (i==9) {
      cout << "cmrg";
    } else if (i==10) {
      cout << "mrg";
    } else if (i==11) {
      cout << "taus";
    } else if (i==12) {
      cout << "taus2";
    } else if (i==13) {
      cout << "gfsr4";
    } else if (i==14) {
      cout << "rand";
    } else if (i==15) {
      cout << "random_bsd";
    } else if (i==16) {
      cout << "random_libc5";
    } else if (i==17) {
      cout << "random_glibc2";
    } else if (i==18) {
      cout << "rand48";
    } else if (i==19) {
      cout << "ranf";
    } else if (i==20) {
      cout << "ranmar";
    } else if (i==21) {
      cout << "r250";
    } else if (i==22) {
      cout << "tt800";
    } else if (i==23) {
      cout << "vax";
    } else if (i==24) {
      cout << "transputer";
    } else if (i==25) {
      cout << "randu";
    } else if (i==26) {
      cout << "minstd";
    } else if (i==27) {
      cout << "uni";
    } else if (i==28) {
      cout << "uni32";
    } else if (i==29) {
      cout << "slatec";
    } else if (i==30) {
      cout << "zuf";
    } else if (i==31) {
      cout << "borosh13";
    } else if (i==32) {
      cout << "coveyou";
    } else if (i==33) {
      cout << "fishman18";
    } else if (i==34) {
      cout << "fishman20";
    } else if (i==35) {
      cout << "fishman2x";
    } else if (i==36) {
      cout << "knuthran2";
    } else if (i==37) {
      cout << "knuthran";
    } else if (i==38) {
      cout << "lecuyer21";
    } else if (i==39) {
      cout << "waterman14";
    }

    lt1=clock();
    for(j=0;j<maxit;j++) {
      x=nr->random();
    }
    lt2=clock();
    cout << ((double)(lt2-lt1))/CLOCKS_PER_SEC << " ";

    lt1=clock();
    for(j=0;j<maxit;j++) {
      y=nr->random_int(10);
    }
    lt2=clock();
    cout << ((double)(lt2-lt1))/CLOCKS_PER_SEC << endl;
  }
    
  t.report();
  return 0;
}


