(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     33282,       1035]*)
(*NotebookOutlinePosition[     34087,       1062]*)
(*  CellTagsIndexPosition[     34043,       1058]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[
    \(\(\(\(Off[General::"\<spell\>"]\) \)\(;\)\(\ \)\(\(Off[
        General::"\<spell1\>"]\) \)\(;\)\(\ \)\)\)], "Input"],

Cell["\<\
Put the original Skyrme interaction in to see that we get what we \
expect
from the gradient terms:\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(P1 = t1/4 \((1 + x1/2)\)\)], "Input"],

Cell[BoxData[
    \(1\/4\ t1\ \((1 + x1\/2)\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(P2 = t2/4 \((1 + x2/2)\)\)], "Input"],

Cell[BoxData[
    \(1\/4\ t2\ \((1 + x2\/2)\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Q1 = t1/4 \((1/2 + x1)\)\)], "Input"],

Cell[BoxData[
    \(1\/4\ t1\ \((1\/2 + x1)\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Q2 = t2/4 \((1/2 + x2)\)\)], "Input"],

Cell[BoxData[
    \(1\/4\ t2\ \((1\/2 + x2)\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(P1f = P1\)], "Input"],

Cell[BoxData[
    \(1\/4\ t1\ \((1 + x1\/2)\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(P2f = P2\)], "Input"],

Cell[BoxData[
    \(1\/4\ t2\ \((1 + x2\/2)\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dQ2dn = 0\)], "Input"],

Cell[BoxData[
    \(0\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Hgradient = 
      Simplify[\[IndentingNewLine]\(-1\)/
              4 \((2\ P1 + P1f - P2f)\) \((nn[z] + 
                np[z])\)\ \((\(nn\^\[Prime]\[Prime]\)[
                  z] + \(np\^\[Prime]\[Prime]\)[z])\)\[IndentingNewLine] + 
          1/2 \((Q1 + Q2)\)\ \((nn[z]\ \(nn\^\[Prime]\[Prime]\)[z] + 
                np[z]\ \(np\^\[Prime]\[Prime]\)[z])\)\[IndentingNewLine] - 
          1/4 \((Q1 - 
                Q2)\) \((\(nn\^\[Prime]\)[z]\^2 + \(np\^\[Prime]\)[z]\^2)\)\
\[IndentingNewLine] + 
          dQ2dn/2 \((nn[z]\^\[Prime]\ nn[z] + 
                np[z]\ \(np\^\[Prime]\)[z])\) \((\(nn\^\[Prime]\)[
                  z] + \(np\^\[Prime]\)[z])\)]\)], "Input"],

Cell[BoxData[
    RowBox[{\(1\/32\), " ", 
      RowBox[{"(", 
        RowBox[{
          RowBox[{\(-\((t1 + 2\ t1\ x1 - t2\ \((1 + 2\ x2)\))\)\), " ", 
            RowBox[{"(", 
              RowBox[{
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["nn", "\[Prime]",
                      MultilineFunction->None], "[", "z", "]"}], "2"], "+", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["np", "\[Prime]",
                      MultilineFunction->None], "[", "z", "]"}], "2"]}], 
              ")"}]}], "-", 
          
          RowBox[{\((3\ t1\ \((2 + x1)\) - t2\ \((2 + x2)\))\), 
            " ", \((nn[z] + np[z])\), " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{
                  SuperscriptBox["nn", "\[Prime]\[Prime]",
                    MultilineFunction->None], "[", "z", "]"}], "+", 
                RowBox[{
                  SuperscriptBox["np", "\[Prime]\[Prime]",
                    MultilineFunction->None], "[", "z", "]"}]}], ")"}]}], "+",
           
          RowBox[{"2", " ", \((t1 + t2 + 2\ t1\ x1 + 2\ t2\ x2)\), " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{\(nn[z]\), " ", 
                  RowBox[{
                    SuperscriptBox["nn", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "z", "]"}]}], "+", 
                RowBox[{\(np[z]\), " ", 
                  RowBox[{
                    SuperscriptBox["np", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "z", "]"}]}]}], 
              ")"}]}]}], ")"}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Hgradient2 = \(-1\)/
            16 \((3\ t1 \((1 + x1/2)\) - t2 \((1 + x2/2)\))\) \((nn[z] + 
              np[z])\)\ \((\(nn\^\[Prime]\[Prime]\)[
                z] + \(np\^\[Prime]\[Prime]\)[z])\) + 
        1/16 \((3\ t1 \((1/2 + x1)\) + 
              t2 \((1/2 + x2)\))\)\ \((nn[z]\ \(nn\^\[Prime]\[Prime]\)[z] + 
              np[z]\ \(np\^\[Prime]\[Prime]\)[z])\)\)], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{\(-\(1\/16\)\), 
        " ", \((3\ t1\ \((1 + x1\/2)\) - t2\ \((1 + x2\/2)\))\), 
        " ", \((nn[z] + np[z])\), " ", 
        RowBox[{"(", 
          RowBox[{
            RowBox[{
              SuperscriptBox["nn", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "z", "]"}], "+", 
            RowBox[{
              SuperscriptBox["np", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "z", "]"}]}], ")"}]}], "+", 
      RowBox[{\(1\/16\), 
        " ", \((3\ t1\ \((1\/2 + x1)\) + t2\ \((1\/2 + x2)\))\), " ", 
        RowBox[{"(", 
          RowBox[{
            RowBox[{\(nn[z]\), " ", 
              RowBox[{
                SuperscriptBox["nn", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "z", "]"}]}], "+", 
            RowBox[{\(np[z]\), " ", 
              RowBox[{
                SuperscriptBox["np", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "z", "]"}]}]}], 
          ")"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Simplify[\(\((Hgradient - Hgradient2)\) /. \(nn\^\[Prime]\)[z] \[Rule] 
            Sqrt[\(-nn[z]\)\ \(nn\^\[Prime]\[Prime]\)[
                  z]]\) /. \(np\^\[Prime]\)[z] \[Rule] 
          Sqrt[\(-np[z]\)\ \(np\^\[Prime]\[Prime]\)[z]]]\)], "Input"],

Cell[BoxData[
    \(0\)], "Output"]
}, Open  ]],

Cell["The original APR Lagrangian:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(HAPR = \((\(h\^2/2\)/
                m + \((p3 + \((1 - x)\) 
                      p5)\) \[Rho]\ Exp[\(-p4\)\ \[Rho]])\) \[Tau]n + \((\(\
\.12h\^2/2\)/m + \((p3 + 
                    x\ p5)\) \[Rho]\ Exp[\(-p4\)\ \[Rho]])\) \[Tau]p + \((1 - \
\((1 - 2  x)\)\^2)\) \((\(-\[Rho]\^2\) \((p1 + p2\ \[Rho] + 
                  p6\ \[Rho]\^2 + \((p10 + p11)\) 
                    Exp[\(-p9\^2\) \[Rho]\^2])\))\) + \(\((1 - 
                  2\ x)\)\^2\) \((\(-\[Rho]\^2\) \((p12/\[Rho] + p7 + 
                  p8\ \[Rho] + 
                  p13\ Exp[\(-p9\^2\) \[Rho]\^2])\))\)\)], "Input"],

Cell[BoxData[
    \(\(-\((1 - 2\ x)\)\^2\)\ \[Rho]\^2\ \((\[ExponentialE]\^\(\(-p9\^2\)\ \
\[Rho]\^2\)\ p13 + p7 + p12\/\[Rho] + 
            p8\ \[Rho])\) - \((1 - \((1 - 2\ x)\)\^2)\)\ \[Rho]\^2\ \((p1 + \
\[ExponentialE]\^\(\(-p9\^2\)\ \[Rho]\^2\)\ \((p10 + p11)\) + p2\ \[Rho] + 
            p6\ \[Rho]\^2)\) + \((h\^2\/\(2\ m\) + \[ExponentialE]\^\(\(-p4\)\
\ \[Rho]\)\ \((p3 + 
                  p5\ \((1 - 
                        x)\))\)\ \[Rho])\)\ \[Tau]n + \((\.12h\^2\/\(2\ m\) + \
\[ExponentialE]\^\(\(-p4\)\ \[Rho]\)\ \((p3 + 
                  p5\ x)\)\ \[Rho])\)\ \[Tau]p\)], "Output"]
}, Open  ]],

Cell["The kinetic terms:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(HkinAPR = \((\(h\^2/2\)/
                m + \((n\ p3 + 
                    nn\ p5)\)\ Exp[\(-p4\)\ n])\) \[Tau]n + \((\(h\^2/2\)/
                m + \((p3\ n + 
                    np\ p5)\)\ Exp[\(-p4\)\ n])\) \[Tau]p\)], "Input"],

Cell[BoxData[
    \(\((h\^2\/\(2\ m\) + \[ExponentialE]\^\(\(-n\)\ p4\)\ \((n\ p3 + 
                  nn\ p5)\))\)\ \[Tau]n + \((h\^2\/\(2\ m\) + \[ExponentialE]\
\^\(\(-n\)\ p4\)\ \((n\ p3 + np\ p5)\))\)\ \[Tau]p\)], "Output"]
}, Open  ]],

Cell["Pethick, et. al.'s definition of the P's and Q's:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(P1 = \((p3/2 - p5)\)\ Exp[\(-n\)\ p4]\)], "Input"],

Cell[BoxData[
    \(\[ExponentialE]\^\(\(-n\)\ p4\)\ \((p3\/2 - p5)\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(P2 = \((p3/2 + p5)\)\ Exp[\(-n\)\ p4]\)], "Input"],

Cell[BoxData[
    \(\[ExponentialE]\^\(\(-n\)\ p4\)\ \((p3\/2 + p5)\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Q1 = P1/2\)], "Input"],

Cell[BoxData[
    \(1\/2\ \[ExponentialE]\^\(\(-n\)\ p4\)\ \((p3\/2 - p5)\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Q2 = P2/2\)], "Input"],

Cell[BoxData[
    \(1\/2\ \[ExponentialE]\^\(\(-n\)\ p4\)\ \((p3\/2 + p5)\)\)], "Output"]
}, Open  ]],

Cell["\<\
Demonstrate that this gives us what we expect, namely, the kinetic \
part of the APR Hamiltonian:\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(HkinPRL = \((\(h\^2/2\)/m + \((P1 + P2)\) n - \((Q1 - Q2)\) 
                nn)\) \[Tau]n + \((\(h\^2/2\)/m + \((P1 + P2)\) 
                n - \((Q1 - Q2)\) np)\) \[Tau]p\)], "Input"],

Cell[BoxData[
    \(\((h\^2\/\(2\ m\) - 
            nn\ \((1\/2\ \[ExponentialE]\^\(\(-n\)\ p4\)\ \((p3\/2 - p5)\) - 
                  1\/2\ \[ExponentialE]\^\(\(-n\)\ p4\)\ \((p3\/2 + 
                        p5)\))\) + 
            n\ \((\[ExponentialE]\^\(\(-n\)\ p4\)\ \((p3\/2 - 
                        p5)\) + \[ExponentialE]\^\(\(-n\)\ p4\)\ \((p3\/2 + 
                        p5)\))\))\)\ \[Tau]n + \((h\^2\/\(2\ m\) - 
            np\ \((1\/2\ \[ExponentialE]\^\(\(-n\)\ p4\)\ \((p3\/2 - p5)\) - 
                  1\/2\ \[ExponentialE]\^\(\(-n\)\ p4\)\ \((p3\/2 + 
                        p5)\))\) + 
            n\ \((\[ExponentialE]\^\(\(-n\)\ p4\)\ \((p3\/2 - 
                        p5)\) + \[ExponentialE]\^\(\(-n\)\ p4\)\ \((p3\/2 + 
                        p5)\))\))\)\ \[Tau]p\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Simplify[HkinAPR - HkinPRL]\)], "Input"],

Cell[BoxData[
    \(0\)], "Output"]
}, Open  ]],

Cell["Now define the new terms P1f and P2f, and dQ2dn:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(P1f = \((Integrate[P1, {n, 0, np}]/np)\) /. np \[Rule] n\)], "Input"],

Cell[BoxData[
    \(\(\[ExponentialE]\^\(\(-n\)\ p4\)\ \((\(-1\) + \[ExponentialE]\^\(n\ p4\
\))\)\ \((p3 - 2\ p5)\)\)\/\(2\ n\ p4\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(P2f = \((Integrate[P2, {n, 0, np}]/np)\) /. np \[Rule] n\)], "Input"],

Cell[BoxData[
    \(\(\[ExponentialE]\^\(\(-n\)\ p4\)\ \((\(-1\) + \[ExponentialE]\^\(n\ p4\
\))\)\ \((p3 + 2\ p5)\)\)\/\(2\ n\ p4\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dQ2dn = D[Q2, n]\)], "Input"],

Cell[BoxData[
    \(\(-\(1\/2\)\)\ \[ExponentialE]\^\(\(-n\)\ p4\)\ p4\ \((p3\/2 + 
          p5)\)\)], "Output"]
}, Open  ]],

Cell["Write the gradient part of the Hamiltonian", "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(Hgradient = \[IndentingNewLine]\(-1\)/4 
         Simplify[\((2\ P1 + P1f - P2f)\)\ ] \((nn[z] + 
            np[z])\)\ \((\(nn\^\[Prime]\[Prime]\)[
              z] + \(np\^\[Prime]\[Prime]\)[z])\)\), "\[IndentingNewLine]", 
    \(\(+1\)/2 
       Simplify[\((Q1 + Q2)\)]\ \((nn[z]\ \(nn\^\[Prime]\[Prime]\)[z] + 
          np[z]\ \(np\^\[Prime]\[Prime]\)[z])\)\), "\[IndentingNewLine]", 
    \(\(-1\)/4 
       Simplify[\((Q1 - 
            Q2)\)] \((\(nn\^\[Prime]\)[z]\^2 + \(np\^\[Prime]\)[z]\^2)\)\), "\
\[IndentingNewLine]", 
    \(\(+1\)\ Simplify[dQ2dn]/
        2 \((nn[z]\ \(nn\^\[Prime]\)[z] + 
          np[z]\ \(np\^\[Prime]\)[z])\) \((\(nn\^\[Prime]\)[
            z] + \(np\^\[Prime]\)[z])\)\)}], "Input"],

Cell[BoxData[
    RowBox[{"-", 
      FractionBox[
        RowBox[{\(\[ExponentialE]\^\(\(-n\)\ p4\)\), 
          " ", \((n\ p4\ \((p3 - 2\ p5)\) - 
              2\ \((\(-1\) + \[ExponentialE]\^\(n\ p4\))\)\ p5)\), 
          " ", \((nn[z] + np[z])\), " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                SuperscriptBox["nn", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "z", "]"}], "+", 
              RowBox[{
                SuperscriptBox["np", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "z", "]"}]}], 
            ")"}]}], \(4\ n\ p4\)]}]], "Output"],

Cell[BoxData[
    RowBox[{\(1\/4\), " ", \(\[ExponentialE]\^\(\(-n\)\ p4\)\), " ", "p3", 
      " ", 
      RowBox[{"(", 
        RowBox[{
          RowBox[{\(nn[z]\), " ", 
            RowBox[{
              SuperscriptBox["nn", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "z", "]"}]}], "+", 
          RowBox[{\(np[z]\), " ", 
            RowBox[{
              SuperscriptBox["np", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "z", "]"}]}]}], 
        ")"}]}]], "Output"],

Cell[BoxData[
    RowBox[{\(1\/4\), " ", \(\[ExponentialE]\^\(\(-n\)\ p4\)\), " ", "p5", 
      " ", 
      RowBox[{"(", 
        RowBox[{
          SuperscriptBox[
            RowBox[{
              SuperscriptBox["nn", "\[Prime]",
                MultilineFunction->None], "[", "z", "]"}], "2"], "+", 
          SuperscriptBox[
            RowBox[{
              SuperscriptBox["np", "\[Prime]",
                MultilineFunction->None], "[", "z", "]"}], "2"]}], 
        ")"}]}]], "Output"],

Cell[BoxData[
    RowBox[{\(-\(1\/8\)\), " ", \(\[ExponentialE]\^\(\(-n\)\ p4\)\), " ", 
      "p4", " ", \((p3 + 2\ p5)\), " ", 
      RowBox[{"(", 
        RowBox[{
          RowBox[{
            SuperscriptBox["nn", "\[Prime]",
              MultilineFunction->None], "[", "z", "]"}], "+", 
          RowBox[{
            SuperscriptBox["np", "\[Prime]",
              MultilineFunction->None], "[", "z", "]"}]}], ")"}], " ", 
      RowBox[{"(", 
        RowBox[{
          RowBox[{\(nn[z]\), " ", 
            RowBox[{
              SuperscriptBox["nn", "\[Prime]",
                MultilineFunction->None], "[", "z", "]"}]}], "+", 
          RowBox[{\(np[z]\), " ", 
            RowBox[{
              SuperscriptBox["np", "\[Prime]",
                MultilineFunction->None], "[", "z", "]"}]}]}], 
        ")"}]}]], "Output"]
}, Open  ]],

Cell["Use Paul's rewriting to remove the second derivatives:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Hgradnew = 
      Simplify[1/
              4 \((3\ P1\  + 2\ n\ D[P1, n] - 
                P2)\) \((\(nn\^\[Prime]\)[z] + \(np\^\[Prime]\)[z])\)\^2 - 
          1/4 \((3\ Q1\  + \ 
                Q2)\) \((\(nn\^\[Prime]\)[z]\^2 + \(np\^\[Prime]\)[z]\^2)\) - 
          1/2\ D[Q1, 
              n] \((nn[z]\ \(nn\^\[Prime]\)[z]\^2 + 
                np[z]\ \(np\^\[Prime]\)[z]\^2 + \((nn[z] + 
                      np[z])\) \(nn\^\[Prime]\)[z]\ \(np\^\[Prime]\)[
                    z])\)]\)], "Input"],

Cell[BoxData[
    RowBox[{\(1\/8\), " ", \(\[ExponentialE]\^\(\(-n\)\ p4\)\), " ", 
      RowBox[{"(", 
        RowBox[{
          
          RowBox[{\((\(-2\)\ n\ p4\ \((p3 - 2\ p5)\) - 6\ p5 + 
                p4\ \((p3 - 2\ p5)\)\ nn[z])\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["nn", "\[Prime]",
                  MultilineFunction->None], "[", "z", "]"}], "2"]}], "+", 
          
          RowBox[{\((4\ \((p3 - n\ p3\ p4 - 4\ p5 + 2\ n\ p4\ p5)\) + 
                p4\ \((p3 - 2\ p5)\)\ nn[z] + p4\ \((p3 - 2\ p5)\)\ np[z])\), 
            " ", 
            RowBox[{
              SuperscriptBox["nn", "\[Prime]",
                MultilineFunction->None], "[", "z", "]"}], " ", 
            RowBox[{
              SuperscriptBox["np", "\[Prime]",
                MultilineFunction->None], "[", "z", "]"}]}], "+", 
          
          RowBox[{\((\(-2\)\ n\ p4\ \((p3 - 2\ p5)\) - 6\ p5 + 
                p4\ \((p3 - 2\ p5)\)\ np[z])\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["np", "\[Prime]",
                  MultilineFunction->None], "[", "z", "]"}], "2"]}]}], 
        ")"}]}]], "Output"]
}, Open  ]],

Cell["Put in the usual form, with density dependent Q's", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Qnnnew = 
      2  Simplify[\((\(Hgradnew /. \(np\^\[Prime]\)[z] \[Rule] 0\) /. 
                n \[Rule] nn[z] + np[z])\)/\(nn\^\[Prime]\)[z]\^2]\)], "Input"],

Cell[BoxData[
    \(1\/4\ \[ExponentialE]\^\(\(-p4\)\ \((nn[z] + np[z])\)\)\ \((\(-6\)\ p5 \
- p4\ \((p3 - 2\ p5)\)\ nn[z] - 2\ p4\ \((p3 - 2\ p5)\)\ np[z])\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(tmp = 
      SeriesCoefficient[Series[Hgradnew, {\(nn\^\[Prime]\)[z], 0, 1}], 
          1]/\(np\^\[Prime]\)[z]\)], "Input"],

Cell[BoxData[
    \(1\/8\ \[ExponentialE]\^\(\(-n\)\ p4\)\ \((4\ \((p3 - n\ p3\ p4 - 
                4\ p5 + 2\ n\ p4\ p5)\) + p4\ \((p3 - 2\ p5)\)\ nn[z] + 
          p4\ \((p3 - 2\ p5)\)\ np[z])\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Qnpnew = Simplify[\((tmp /. n \[Rule] nn[z] + np[z])\)]\)], "Input"],

Cell[BoxData[
    \(1\/8\ \[ExponentialE]\^\(\(-p4\)\ \((nn[z] + np[z])\)\)\ \((4\ \((p3 - 
                4\ p5)\) - 3\ p4\ \((p3 - 2\ p5)\)\ nn[z] - 
          3\ p4\ \((p3 - 2\ p5)\)\ np[z])\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Qppnew = 
      2  Simplify[\((\(Hgradnew /. \(nn\^\[Prime]\)[z] \[Rule] 0\) /. 
                n \[Rule] nn[z] + np[z])\)/\(np\^\[Prime]\)[z]\^2]\)], "Input"],

Cell[BoxData[
    \(1\/4\ \[ExponentialE]\^\(\(-p4\)\ \((nn[z] + np[z])\)\)\ \((\(-6\)\ p5 \
- 2\ p4\ \((p3 - 2\ p5)\)\ nn[z] - p4\ \((p3 - 2\ p5)\)\ np[z])\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(Qnnnew /. nn[z] \[Rule] 0\) /. np[z] \[Rule] 0\) /. 
      p5 \[Rule] \(-59.0\)\)], "Input"],

Cell[BoxData[
    \(88.5`\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\(Qnpnew /. nn[z] \[Rule] 0\) /. np[z] \[Rule] 0\) /. 
        p5 \[Rule] \(-59.0\)\) /. p3 \[Rule] 89.9\)], "Input"],

Cell[BoxData[
    \(162.95`\)], "Output"]
}, Open  ]],

Cell["Take derivatives so that we can easily write the Diff Eq's:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \({Simplify[D[Qnnnew, nn[z]]], Simplify[D[Qnnnew, np[z]]]}\)], "Input"],

Cell[BoxData[
    \({1\/4\ \[ExponentialE]\^\(\(-p4\)\ \((nn[z] + np[z])\)\)\ p4\ \
\((\(-p3\) + 8\ p5 + p4\ \((p3 - 2\ p5)\)\ nn[z] + 
            2\ p4\ \((p3 - 2\ p5)\)\ np[z])\), 
      1\/4\ \[ExponentialE]\^\(\(-p4\)\ \((nn[z] + np[z])\)\)\ p4\ \((p4\ \
\((p3 - 2\ p5)\)\ nn[z] + 
            2\ \((\(-p3\) + 5\ p5 + 
                  p4\ \((p3 - 2\ p5)\)\ np[z])\))\)}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \({Simplify[D[Qnpnew, nn[z]]], Simplify[D[Qnpnew, np[z]]]}\)], "Input"],

Cell[BoxData[
    \({1\/8\ \[ExponentialE]\^\(\(-p4\)\ \((nn[z] + np[z])\)\)\ p4\ \((\(-7\)\
\ p3 + 22\ p5 + 3\ p4\ \((p3 - 2\ p5)\)\ nn[z] + 
            3\ p4\ \((p3 - 2\ p5)\)\ np[z])\), 
      1\/8\ \[ExponentialE]\^\(\(-p4\)\ \((nn[z] + np[z])\)\)\ p4\ \((\(-7\)\ \
p3 + 22\ p5 + 3\ p4\ \((p3 - 2\ p5)\)\ nn[z] + 
            3\ p4\ \((p3 - 2\ p5)\)\ np[z])\)}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \({Simplify[D[Qppnew, nn[z]]], Simplify[D[Qppnew, np[z]]]}\)], "Input"],

Cell[BoxData[
    \({1\/4\ \[ExponentialE]\^\(\(-p4\)\ \((nn[z] + np[z])\)\)\ p4\ \((\(-2\)\
\ \((p3 - 5\ p5)\) + 2\ p4\ \((p3 - 2\ p5)\)\ nn[z] + 
            p4\ \((p3 - 2\ p5)\)\ np[z])\), 
      1\/4\ \[ExponentialE]\^\(\(-p4\)\ \((nn[z] + np[z])\)\)\ p4\ \((\(-p3\) \
+ 8\ p5 + 2\ p4\ \((p3 - 2\ p5)\)\ nn[z] + 
            p4\ \((p3 - 2\ p5)\)\ np[z])\)}\)], "Output"]
}, Open  ]],

Cell["Check:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Simplify[
      Qnnnew\ \(nn\^\[Prime]\)[z]\^2/2 + 
          Qnpnew\ \(np\^\[Prime]\)[z] \(nn\^\[Prime]\)[z] + 
          Qppnew\ \(np\^\[Prime]\)[z]\^2/2 - Hgradnew /. 
        n \[Rule] nn[z] + np[z]]\)], "Input"],

Cell[BoxData[
    \(0\)], "Output"]
}, Open  ]],

Cell["Get boundary conditions:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(nn = nn0 - \[Delta]\ Exp[\(-\[Alpha]\)\ x]\)], "Input"],

Cell[BoxData[
    \(nn0 - \[ExponentialE]\^\(\(-x\)\ \[Alpha]\)\ \[Delta]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(np = np0 - \[Epsilon]\ Exp[\(-\[Alpha]\)\ x]\)], "Input"],

Cell[BoxData[
    \(np0 - \[ExponentialE]\^\(\(-x\)\ \[Alpha]\)\ \[Epsilon]\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(nnp = D[nn, x]; \ npp = D[np, x]; \ nnpp = D[nnp, x]; \ 
    nppp = D[npp, x];\)], "Input"],

Cell["Old boundary condition equation:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(eq1 = 
      Simplify[Exp[\[Alpha]\ x] \((Qnn\ nnpp + Qnp\ nppp)\) \[Equal] 
          Exp[\[Alpha]\ x] \((dmundnn\ \((nn - nn0)\)\  + 
                dmundnp\ \((np - np0)\))\)]\)], "Input"],

Cell[BoxData[
    \(dmundnn\ \[Delta] + 
        dmundnp\ \[Epsilon] \[Equal] \[Alpha]\^2\ \((Qnn\ \[Delta] + 
            Qnp\ \[Epsilon])\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Solve[eq1, \[Epsilon]]\)], "Input"],

Cell[BoxData[
    \({{\[Epsilon] \[Rule] \(\(-dmundnn\)\ \[Delta] + Qnn\ \[Alpha]\^2\ \
\[Delta]\)\/\(dmundnp - Qnp\ \[Alpha]\^2\)}}\)], "Output"]
}, Open  ]],

Cell["New boundary condition equation:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(eq2 = \((Qnn\ nnpp + 
            Qnp\ nppp)\) \[Equal] \((dmundnn\ \((nn - nn0)\)\  + 
            dmundnp\ \((np - np0)\) + dqnndnn\ nnp\^2/2 + dqnpdnn\ nnp\ npp + 
            dqppdnn\ npp\^2/2)\)\)], "Input"],

Cell[BoxData[
    \(\(-\[ExponentialE]\^\(\(-x\)\ \[Alpha]\)\)\ Qnn\ \[Alpha]\^2\ \[Delta] \
- \[ExponentialE]\^\(\(-x\)\ \[Alpha]\)\ Qnp\ \[Alpha]\^2\ \[Epsilon] \
\[Equal] \(-dmundnn\)\ \[ExponentialE]\^\(\(-x\)\ \[Alpha]\)\ \[Delta] + 
        1\/2\ dqnndnn\ \[ExponentialE]\^\(\(-2\)\ x\ \[Alpha]\)\ \[Alpha]\^2\ \
\[Delta]\^2 - dmundnp\ \[ExponentialE]\^\(\(-x\)\ \[Alpha]\)\ \[Epsilon] + 
        dqnpdnn\ \[ExponentialE]\^\(\(-2\)\ x\ \[Alpha]\)\ \[Alpha]\^2\ \
\[Delta]\ \[Epsilon] + 
        1\/2\ dqppdnn\ \[ExponentialE]\^\(\(-2\)\ x\ \[Alpha]\)\ \[Alpha]\^2\ \
\[Epsilon]\^2\)], "Output"]
}, Open  ]],

Cell["\<\
Note that since the exponents are even smaller, that we can use the \
old
boundary conditions to first order.\
\>", "Text"],

Cell["Now go back to the Skyrme form:", "Text"],

Cell[BoxData[
    \(Clear["\<nn\>"]; \ Clear["\<np\>"]; \ Clear["\<n\>"];\)], "Input"],

Cell[BoxData[
    \(P1 = t1[n]/4; \ P2 = t2[n]/4; \ Q1 = t1[n]/8; \ 
    Q2 = t2[n]/8;\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Hgradnew = 
      Simplify[1/
              4 \((3\ P1\  + 2\ n\ D[P1, n] - 
                P2)\) \((\(nn\^\[Prime]\)[z] + \(np\^\[Prime]\)[z])\)\^2 - 
          1/4 \((3\ Q1\  + \ 
                Q2)\) \((\(nn\^\[Prime]\)[z]\^2 + \(np\^\[Prime]\)[z]\^2)\) - 
          1/2\ D[Q1, 
              n] \((nn[z]\ \(nn\^\[Prime]\)[z]\^2 + 
                np[z]\ \(np\^\[Prime]\)[z]\^2 + \((nn[z] + 
                      np[z])\) \(nn\^\[Prime]\)[z]\ \(np\^\[Prime]\)[
                    z])\)]\)], "Input"],

Cell[BoxData[
    RowBox[{\(1\/32\), " ", 
      RowBox[{"(", 
        RowBox[{
          RowBox[{"3", " ", \(t1[n]\), " ", 
            RowBox[{"(", 
              RowBox[{
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["nn", "\[Prime]",
                      MultilineFunction->None], "[", "z", "]"}], "2"], "+", 
                RowBox[{"4", " ", 
                  RowBox[{
                    SuperscriptBox["nn", "\[Prime]",
                      MultilineFunction->None], "[", "z", "]"}], " ", 
                  RowBox[{
                    SuperscriptBox["np", "\[Prime]",
                      MultilineFunction->None], "[", "z", "]"}]}], "+", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["np", "\[Prime]",
                      MultilineFunction->None], "[", "z", "]"}], "2"]}], 
              ")"}]}], "-", 
          RowBox[{\(t2[n]\), " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{"3", " ", 
                  SuperscriptBox[
                    RowBox[{
                      SuperscriptBox["nn", "\[Prime]",
                        MultilineFunction->None], "[", "z", "]"}], "2"]}], 
                "+", 
                RowBox[{"4", " ", 
                  RowBox[{
                    SuperscriptBox["nn", "\[Prime]",
                      MultilineFunction->None], "[", "z", "]"}], " ", 
                  RowBox[{
                    SuperscriptBox["np", "\[Prime]",
                      MultilineFunction->None], "[", "z", "]"}]}], "+", 
                RowBox[{"3", " ", 
                  SuperscriptBox[
                    RowBox[{
                      SuperscriptBox["np", "\[Prime]",
                        MultilineFunction->None], "[", "z", "]"}], "2"]}]}], 
              ")"}]}], "+", 
          RowBox[{"2", " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{
                  SuperscriptBox["nn", "\[Prime]",
                    MultilineFunction->None], "[", "z", "]"}], "+", 
                RowBox[{
                  SuperscriptBox["np", "\[Prime]",
                    MultilineFunction->None], "[", "z", "]"}]}], ")"}], " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{\((2\ n - nn[z])\), " ", 
                  RowBox[{
                    SuperscriptBox["nn", "\[Prime]",
                      MultilineFunction->None], "[", "z", "]"}]}], "+", 
                RowBox[{\((2\ n - np[z])\), " ", 
                  RowBox[{
                    SuperscriptBox["np", "\[Prime]",
                      MultilineFunction->None], "[", "z", "]"}]}]}], ")"}], 
            " ", 
            RowBox[{
              SuperscriptBox["t1", "\[Prime]",
                MultilineFunction->None], "[", "n", "]"}]}]}], 
        ")"}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Qnnnew = 
      2  Simplify[\((Hgradnew /. \(np\^\[Prime]\)[z] \[Rule] 
                  0)\)/\(nn\^\[Prime]\)[z]\^2]\)], "Input"],

Cell[BoxData[
    RowBox[{\(1\/16\), " ", 
      RowBox[{"(", 
        RowBox[{\(3\ t1[n]\), "-", \(3\ t2[n]\), "+", 
          RowBox[{"2", " ", \((2\ n - nn[z])\), " ", 
            RowBox[{
              SuperscriptBox["t1", "\[Prime]",
                MultilineFunction->None], "[", "n", "]"}]}]}], 
        ")"}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(tmp = 
      SeriesCoefficient[Series[Hgradnew, {\(nn\^\[Prime]\)[z], 0, 1}], 
          1]/\(np\^\[Prime]\)[z]\)], "Input"],

Cell[BoxData[
    RowBox[{
      FractionBox["1", 
        RowBox[{
          SuperscriptBox["np", "\[Prime]",
            MultilineFunction->None], "[", "z", "]"}]], 
      RowBox[{"(", 
        RowBox[{
          RowBox[{\(3\/8\), " ", \(t1[n]\), " ", 
            RowBox[{
              SuperscriptBox["np", "\[Prime]",
                MultilineFunction->None], "[", "z", "]"}]}], "-", 
          RowBox[{\(1\/8\), " ", \(t2[n]\), " ", 
            RowBox[{
              SuperscriptBox["np", "\[Prime]",
                MultilineFunction->None], "[", "z", "]"}]}], "+", 
          RowBox[{\(1\/4\), " ", "n", " ", 
            RowBox[{
              SuperscriptBox["np", "\[Prime]",
                MultilineFunction->None], "[", "z", "]"}], " ", 
            RowBox[{
              SuperscriptBox["t1", "\[Prime]",
                MultilineFunction->None], "[", "n", "]"}]}], "-", 
          RowBox[{\(1\/16\), " ", \(nn[z]\), " ", 
            RowBox[{
              SuperscriptBox["np", "\[Prime]",
                MultilineFunction->None], "[", "z", "]"}], " ", 
            RowBox[{
              SuperscriptBox["t1", "\[Prime]",
                MultilineFunction->None], "[", "n", "]"}]}], "-", 
          RowBox[{\(1\/16\), " ", \(np[z]\), " ", 
            RowBox[{
              SuperscriptBox["np", "\[Prime]",
                MultilineFunction->None], "[", "z", "]"}], " ", 
            RowBox[{
              SuperscriptBox["t1", "\[Prime]",
                MultilineFunction->None], "[", "n", "]"}]}]}], 
        ")"}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Qnpnew = Simplify[\((tmp)\)]\)], "Input"],

Cell[BoxData[
    RowBox[{\(1\/16\), " ", 
      RowBox[{"(", 
        RowBox[{\(6\ t1[n]\), "-", \(2\ t2[n]\), "-", 
          RowBox[{\((\(-4\)\ n + nn[z] + np[z])\), " ", 
            RowBox[{
              SuperscriptBox["t1", "\[Prime]",
                MultilineFunction->None], "[", "n", "]"}]}]}], 
        ")"}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Qppnew = 
      2  Simplify[\((Hgradnew /. \(nn\^\[Prime]\)[z] \[Rule] 
                  0)\)/\(np\^\[Prime]\)[z]\^2]\)], "Input"],

Cell[BoxData[
    RowBox[{\(1\/16\), " ", 
      RowBox[{"(", 
        RowBox[{\(3\ t1[n]\), "-", \(3\ t2[n]\), "+", 
          RowBox[{"2", " ", \((2\ n - np[z])\), " ", 
            RowBox[{
              SuperscriptBox["t1", "\[Prime]",
                MultilineFunction->None], "[", "n", "]"}]}]}], 
        ")"}]}]], "Output"]
}, Open  ]],

Cell["Now find t1 and t2 as a function of the effective masses", "Text"],

Cell[BoxData[
    \(tx1 = 1/4 \((t1 + t2)\); \ tx2 = 1/4 \((t2/2 - t1/2)\);\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(eq1 = msn \[Equal] mn/\((1 + 2 \((n\ tx1 + nn\ tx2)\) mn)\)\)], "Input"],

Cell[BoxData[
    \(msn \[Equal] 
      mn\/\(1 + 2\ mn\ \((1\/4\ nn\ \((\(-\(t1\/2\)\) + t2\/2)\) + 1\/4\ n\ \
\((t1 + t2)\))\)\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eq2 = msp \[Equal] mp/\((1 + 2 \((n\ tx1 + np\ tx2)\)\ mp)\)\)], "Input"],

Cell[BoxData[
    \(msp \[Equal] 
      mp\/\(1 + 2\ mp\ \((1\/4\ np\ \((\(-\(t1\/2\)\) + t2\/2)\) + 1\/4\ n\ \
\((t1 + t2)\))\)\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Simplify[Solve[{eq1, eq2}, {t1, t2}]]\)], "Input"],

Cell[BoxData[
    \({{t1 \[Rule] \((2\ mn\ mp\ msn\ n - 2\ mn\ mp\ msp\ n - 
                2\ mn\ msn\ msp\ n + 2\ mp\ msn\ msp\ n + mn\ mp\ msn\ nn - 
                mn\ msn\ msp\ nn - mn\ mp\ msp\ np + 
                mp\ msn\ msp\ np)\)/\((mn\ mp\ msn\ msp\ n\ nn - 
                mn\ mp\ msn\ msp\ n\ np)\), 
        t2 \[Rule] \(-\(\(\(-\((\(-4\)\ mp + 4\ msp)\)\)\ \((2\ mn\ msn\ n - 
                        mn\ msn\ nn)\) + \((\(-4\)\ mn + 
                        4\ msn)\)\ \((2\ mp\ msp\ n - 
                        mp\ msp\ np)\)\)\/\(4\ mn\ mp\ msn\ msp\ n\ nn - 
                  4\ mn\ mp\ msn\ msp\ n\ np\)\)\)}}\)], "Output"]
}, Open  ]],

Cell["What if x=1/2 and nn=np:", "Text"],

Cell[BoxData[
    \(tx1 = 1/4 \((t1 + t2)\); \ tx2 = 1/4 \((t2/2 - t1/2)\);\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(eq1 = msn \[Equal] mn/\((1 + 2 \((n\ tx1 + n/2\ tx2)\) mn)\)\)], "Input"],

Cell[BoxData[
    \(msn \[Equal] 
      mn\/\(1 + 2\ mn\ \((1\/8\ n\ \((\(-\(t1\/2\)\) + t2\/2)\) + 1\/4\ n\ \
\((t1 + t2)\))\)\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eq2 = 
      msp \[Equal] mp/\((1 + 2 \((n\ tx1 + n/2\ tx2)\)\ mp)\)\)], "Input"],

Cell[BoxData[
    \(msp \[Equal] 
      mp\/\(1 + 2\ mp\ \((1\/8\ n\ \((\(-\(t1\/2\)\) + t2\/2)\) + 1\/4\ n\ \
\((t1 + t2)\))\)\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(xol1 = Solve[eq1, t1]\)], "Input"],

Cell[BoxData[
    \({{t1 \[Rule] \(8\ mn - 8\ msn - 5\ mn\ msn\ n\ t2\)\/\(3\ mn\ msn\ \
n\)}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(xol2 = Solve[eq2, t1]\)], "Input"],

Cell[BoxData[
    \({{t1 \[Rule] \(8\ mp - 8\ msp - 5\ mp\ msp\ n\ t2\)\/\(3\ mp\ msp\ \
n\)}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Expand[
      Simplify[\(\(xol1[\([1]\)]\)[\([1]\)]\)[\([2]\)] - \(\(xol2[\([1]\)]\)[\
\([1]\)]\)[\([2]\)]]]\)], "Input"],

Cell[BoxData[
    \(\(-\(8\/\(3\ mn\ n\)\)\) + 8\/\(3\ mp\ n\) + 8\/\(3\ msn\ n\) - 
      8\/\(3\ msp\ n\)\)], "Output"]
}, Open  ]]
},
FrontEndVersion->"5.0 for X",
ScreenRectangle->{{0, 1400}, {0, 1050}},
WindowSize->{653, 942},
WindowMargins->{{1, Automatic}, {Automatic, 3}},
PrintingPageRange->{Automatic, Automatic},
PrintingOptions->{"PaperSize"->{612, 792},
"PaperOrientation"->"Portrait",
"PostScriptOutputFile":>"apr_eos.ps",
"Magnification"->1}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 137, 2, 27, "Input"],
Cell[1894, 55, 123, 4, 50, "Text"],

Cell[CellGroupData[{
Cell[2042, 63, 57, 1, 27, "Input"],
Cell[2102, 66, 59, 1, 44, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2198, 72, 57, 1, 27, "Input"],
Cell[2258, 75, 59, 1, 44, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2354, 81, 57, 1, 27, "Input"],
Cell[2414, 84, 59, 1, 44, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2510, 90, 57, 1, 27, "Input"],
Cell[2570, 93, 59, 1, 44, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2666, 99, 41, 1, 27, "Input"],
Cell[2710, 102, 59, 1, 44, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2806, 108, 41, 1, 27, "Input"],
Cell[2850, 111, 59, 1, 44, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2946, 117, 42, 1, 27, "Input"],
Cell[2991, 120, 35, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3063, 126, 700, 13, 101, "Input"],
Cell[3766, 141, 1670, 39, 78, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[5473, 185, 404, 7, 59, "Input"],
Cell[5880, 194, 1036, 25, 81, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6953, 224, 272, 4, 43, "Input"],
Cell[7228, 230, 35, 1, 27, "Output"]
}, Open  ]],
Cell[7278, 234, 44, 0, 32, "Text"],

Cell[CellGroupData[{
Cell[7347, 238, 612, 11, 91, "Input"],
Cell[7962, 251, 601, 10, 117, "Output"]
}, Open  ]],
Cell[8578, 264, 34, 0, 32, "Text"],

Cell[CellGroupData[{
Cell[8637, 268, 254, 5, 51, "Input"],
Cell[8894, 275, 228, 3, 51, "Output"]
}, Open  ]],
Cell[9137, 281, 65, 0, 32, "Text"],

Cell[CellGroupData[{
Cell[9227, 285, 70, 1, 27, "Input"],
Cell[9300, 288, 83, 1, 44, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[9420, 294, 70, 1, 27, "Input"],
Cell[9493, 297, 83, 1, 44, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[9613, 303, 42, 1, 27, "Input"],
Cell[9658, 306, 89, 1, 44, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[9784, 312, 42, 1, 27, "Input"],
Cell[9829, 315, 89, 1, 44, "Output"]
}, Open  ]],
Cell[9933, 319, 121, 3, 32, "Text"],

Cell[CellGroupData[{
Cell[10079, 326, 206, 3, 51, "Input"],
Cell[10288, 331, 813, 13, 182, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11138, 349, 60, 1, 27, "Input"],
Cell[11201, 352, 35, 1, 27, "Output"]
}, Open  ]],
Cell[11251, 356, 64, 0, 32, "Text"],

Cell[CellGroupData[{
Cell[11340, 360, 89, 1, 27, "Input"],
Cell[11432, 363, 146, 2, 49, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11615, 370, 89, 1, 27, "Input"],
Cell[11707, 373, 146, 2, 49, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11890, 380, 49, 1, 27, "Input"],
Cell[11942, 383, 113, 2, 44, "Output"]
}, Open  ]],
Cell[12070, 388, 58, 0, 32, "Text"],

Cell[CellGroupData[{
Cell[12153, 392, 742, 15, 96, "Input"],
Cell[12898, 409, 644, 15, 49, "Output"],
Cell[13545, 426, 519, 13, 44, "Output"],
Cell[14067, 441, 493, 13, 44, "Output"],
Cell[14563, 456, 831, 21, 44, "Output"]
}, Open  ]],
Cell[15409, 480, 70, 0, 32, "Text"],

Cell[CellGroupData[{
Cell[15504, 484, 526, 11, 87, "Input"],
Cell[16033, 497, 1200, 28, 80, "Output"]
}, Open  ]],
Cell[17248, 528, 65, 0, 32, "Text"],

Cell[CellGroupData[{
Cell[17338, 532, 180, 3, 31, "Input"],
Cell[17521, 537, 172, 2, 44, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[17730, 544, 144, 3, 27, "Input"],
Cell[17877, 549, 213, 3, 44, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[18127, 557, 88, 1, 27, "Input"],
Cell[18218, 560, 210, 3, 44, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[18465, 568, 180, 3, 31, "Input"],
Cell[18648, 573, 172, 2, 44, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[18857, 580, 116, 2, 27, "Input"],
Cell[18976, 584, 39, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[19052, 590, 141, 2, 27, "Input"],
Cell[19196, 594, 41, 1, 27, "Output"]
}, Open  ]],
Cell[19252, 598, 75, 0, 32, "Text"],

Cell[CellGroupData[{
Cell[19352, 602, 89, 1, 27, "Input"],
Cell[19444, 605, 390, 7, 80, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[19871, 617, 89, 1, 27, "Input"],
Cell[19963, 620, 379, 6, 80, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[20379, 631, 89, 1, 27, "Input"],
Cell[20471, 634, 374, 6, 80, "Output"]
}, Open  ]],
Cell[20860, 643, 22, 0, 32, "Text"],

Cell[CellGroupData[{
Cell[20907, 647, 236, 5, 50, "Input"],
Cell[21146, 654, 35, 1, 27, "Output"]
}, Open  ]],
Cell[21196, 658, 40, 0, 32, "Text"],

Cell[CellGroupData[{
Cell[21261, 662, 75, 1, 27, "Input"],
Cell[21339, 665, 87, 1, 28, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[21463, 671, 77, 1, 27, "Input"],
Cell[21543, 674, 89, 1, 28, "Output"]
}, Open  ]],
Cell[21647, 678, 111, 2, 27, "Input"],
Cell[21761, 682, 48, 0, 32, "Text"],

Cell[CellGroupData[{
Cell[21834, 686, 212, 4, 59, "Input"],
Cell[22049, 692, 155, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[22241, 700, 55, 1, 27, "Input"],
Cell[22299, 703, 146, 2, 49, "Output"]
}, Open  ]],
Cell[22460, 708, 48, 0, 32, "Text"],

Cell[CellGroupData[{
Cell[22533, 712, 232, 4, 67, "Input"],
Cell[22768, 718, 600, 9, 80, "Output"]
}, Open  ]],
Cell[23383, 730, 133, 4, 50, "Text"],
Cell[23519, 736, 47, 0, 32, "Text"],
Cell[23569, 738, 86, 1, 27, "Input"],
Cell[23658, 741, 99, 2, 27, "Input"],

Cell[CellGroupData[{
Cell[23782, 747, 526, 11, 87, "Input"],
Cell[24311, 760, 2864, 68, 79, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[27212, 833, 151, 3, 31, "Input"],
Cell[27366, 838, 331, 8, 44, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[27734, 851, 144, 3, 27, "Input"],
Cell[27881, 856, 1549, 37, 84, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[29467, 898, 61, 1, 27, "Input"],
Cell[29531, 901, 334, 8, 44, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[29902, 914, 151, 3, 31, "Input"],
Cell[30056, 919, 331, 8, 44, "Output"]
}, Open  ]],
Cell[30402, 930, 72, 0, 32, "Text"],
Cell[30477, 932, 88, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[30590, 937, 92, 1, 27, "Input"],
Cell[30685, 940, 144, 3, 50, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[30866, 948, 93, 1, 27, "Input"],
Cell[30962, 951, 144, 3, 50, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[31143, 959, 70, 1, 27, "Input"],
Cell[31216, 962, 650, 10, 105, "Output"]
}, Open  ]],
Cell[31881, 975, 40, 0, 32, "Text"],
Cell[31924, 977, 88, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[32037, 982, 93, 1, 27, "Input"],
Cell[32133, 985, 143, 3, 50, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[32313, 993, 101, 2, 27, "Input"],
Cell[32417, 997, 143, 3, 50, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[32597, 1005, 54, 1, 27, "Input"],
Cell[32654, 1008, 108, 2, 44, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[32799, 1015, 54, 1, 27, "Input"],
Cell[32856, 1018, 108, 2, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[33001, 1025, 141, 3, 27, "Input"],
Cell[33145, 1030, 121, 2, 47, "Output"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

